
# Predefinisanje (overload) operatora

class Tacka:
    def __init__(self, x = 0, y = 0):
        self.x = x
        self.y = y 

    def __str__(self):
        return "({0},{1})".format(self.x,self.y)
    
    # +
    def __add__(self, other):
        if isinstance(other, Tacka):
            x = self.x + other.x
            y = self.y + other.y
            return Tacka(x,y)
        else:
            raise TypeError('other must be Tacka')
                    
    # +=
    def __iadd__(self, other):
        if isinstance(other, Tacka):
            self.x += other.x
            self.y += other.y
        else:
            raise TypeError('other must be Tacka')

        return self
    
    # ==
    def __eq__(self, other):
        if isinstance(other, Tacka):
            return self.x == other.x and self.y == other.y
        else:
            # NotImplemented - singleton objekat (operatori poredjenja implicitno se koriste npr. kod sortiranja listi)
            return NotImplemented
        
    # <    
    def __lt__(self, other):
        if isinstance(other, Tacka):
            if self.x == other.x:
                return self.y < other.y
            return self.x < other.x
        else:
            return NotImplemented
    
    # >
    def __gt__(self, other):
        if isinstance(other, Tacka):
            return not self.__lt__(other) and not self.__eq__(other)
        else:
            return NotImplemented


p1 = Tacka(2,3)
p2 = Tacka(-1,2)

p3 = p1 + p2
print(p3)

p1 += Tacka(3, 2)
print(p1)

print(Tacka(-1, 1) < Tacka(0, 1))
print(Tacka(0, 0) < Tacka(0, 1))
print(Tacka(0, 0) < Tacka(-1, 0))

print(Tacka(0,0) == Tacka(0, 0))
print(Tacka(0,0) == Tacka(0, 1))

print(Tacka(-1, 1) > Tacka(0, 1))
print(Tacka(0, 0) > Tacka(0, -1))
print(Tacka(10, 0) > Tacka(-1, 0))


a = Tacka(-5, -5)

# objekti nasih klasa su mutabilni
           # ocekivani tip argumenta (:tip)
def izmeni(a:Tacka):
    #a += Tacka(2, 2) # menja originalni objekat (!)
    a = a + Tacka(2, 2)

print(a)
izmeni(a)
print(a)