# Rad sa fajlovima
import os

# rezimi:
# - "r"  -> read
# - "w"  -> write
# - "a"  -> append
# - "r+" -> read + write
# - "a+" -> append + read

# 1. varijanta
try:
    f = open('1.txt', 'r')
    for line in f:
        print(line)
    f.close() # fajl se nece zatvoriti u slucaju izuzetka (!)
except IOError:
    print('Greska prlikom otvaranja/citanja')

# 2. varijanta
try:
    f = open('5.txt', 'r')
    for line in f:
        print(line)
except IOError:
    print('Greska prilikom otvaranja/citanja')
finally: # izvrsava se u svakom slucaju
    if f: # potrebno proveriti da li je fajl otvoren (IOError mogao da nastupi prilikom otvaranja) 
        f.close()

# 3. varijanta (najispravniji nacin (!))
try:
    with open('1.txt', 'r') as f:
        for line in f:
            print(line)
except IOError:
    print('Greska prilikom otvaranja/citanja')


print("-----Upisivanje u datoteku-----\n")
# razresiti konfuziju izmedju a+ (upisuje na kraj) i r+ (upisuje na pocetak, tj. prepisace postojeci sadrzaj)
# napravice se fajl ako prethodno nije postojao
with open("2.txt","a+") as h:
    h.write("water\n")
    h.write("1234\n")
    h.write("\n")
    h.write("pp")
    # h.flush() - da budemo sigurni da je prebaceno iz bafera
    # nakon write file pointer se pomerio pa da bismo procitali ceo sadrzaj vracamo se na pocetak datoteke
    h.seek(0, os.SEEK_SET) # 1. parametar: offset, 2. parametar: 0 - pocetak fajla (os.SEEK_SET), 1 - trenutna pozicija (os.SEEK_CUR), 2 - kraj fajla (OS.SEEK_END) 
    print(h.readlines())
