# pozicioni argumenti
# imenovani argumenti (uvek iza pozicionih, medjusobno mogu biti izmesani)

def foo(a, b, c):
    return (a+b)**c

print(foo(10, 1, 2))
print(foo(10, b=1, c=2))
# print(foo(10, b=1, 2)) SyntaxError
print(foo(10, c=2, b=1))

# f-ja sa proizvoljno mnogo pozicionih argumenata (ne mora da se zove args)
def make_list(a, b, *args):
    l = []
    l.append(a)
    l.append(b)

    # args - tuple
    for item in args:
        l.append(item)

    return l

print(make_list(1, 'abc'))
print(make_list(1, 'abc', 'cd', [10, 20], 4.2))

# f-ja sa proizvoljno mnogo imenovanih argumenata (ne mora da se zove kwargs)
def keys_values(**kwargs):
    keys = []
    values = []

    for key, value in kwargs.items():
        keys.append(key)
        values.append(value)

    return keys, values

keys, values = keys_values(en='English', de='German', fr='French')
print(keys, values)

# moguce imati i *args i **kwargs (tim redom) u definiciji f-je

