# podrska za apstraktne klase (klase koje sadrze bar jedan apstraktan metod) - ne mogu se instancirati -> TypeError
# apstraktan metod - deklarisan u nadklasi bez implementacije, mora se implementirati u podklasama
from abc import ABC, abstractmethod

# hijerarhijski polimorfizam - svi metodi su efektivno virtuelni, moguce ih je override-ovati iz podklase
# (izuzev ako imaju @staticmethod, @classmethod dekorator ili su privatni) 

class Zivotinja(ABC):
    def __init__(self, ime):
        self.ime = ime
    
    @abstractmethod
    def oglasi_se(self):
        pass

class Pas(Zivotinja):
    def __init__(self, ime, rasa):
        super().__init__(ime)
        self.rasa = rasa

    def oglasi_se(self):
        return f"Woof: {self.ime} - {self.rasa}!"
    

class Macka(Zivotinja):
    def __init__(self, ime, vrsta):
        super().__init__(ime)
        self.vrsta = vrsta

    def oglasi_se(self):
        return f"Meow: {self.ime} - {self.vrsta}!"
    

l = [Pas('Dzeki', 'mesanac'), Macka('Pipi', 'persijska'), Pas('Lea', 'buldog'), Macka('Kristina', 'ruska')]

for item in l:
    print(item.oglasi_se())